/******************************************************************************
 *
 * Read data necessary for the erosion process from a specifically formated text
 * file.
 *
 ******************************************************************************/

#include "read_data.h"

using namespace std;

int read_data(string file, int * index, double * percent, double * volume, double H[LENGTH][WIDTH], double h[LENGTH][WIDTH]) {
	// Open the file that contains the data we need to parse through
	ifstream infile( file.c_str(), ifstream::in );
	
	// Define a string to use as a dummy variable to parse the file
	string s;
	
	// The first line of this file should be the index value
	if ( !getline( infile, s) ) return 0;
	*index = atoi(s.c_str());
	
	// The next line should be the percent value
	if ( !getline(infile, s) ) return 0;
	*percent = atof(s.c_str());
	
	// The third line should be the volume of the original hillside
	if ( !getline(infile, s) ) return 0;
	*volume = atof(s.c_str());
	
	// The remaining lines in the file are the arrays H and h which are the 
	// water surface and water depth, respectively. First we get the water
	// surface values from the file
	for (int i = 0; i < LENGTH; i ++) {
		if ( !getline(infile, s) ) return 0;

		istringstream ss(s);
		for (int j = 0; j < WIDTH; j++) {
			if ( !getline(ss, s, ',') ) return 0;
			H[i][j] = atof(s.c_str());
		}
	}
	// Now get the water depth
	for (int i = 0; i < LENGTH; i ++) {
		if ( !getline(infile, s) ) return 0;		

		istringstream ss(s);
		for (int j = 0; j < WIDTH; j++) {
			if ( !getline(ss, s, ',') ) return 0;
			h[i][j] = atof(s.c_str());
		}
	}

	// We are done reading, close the file.
	infile.close();
	
	// All the data should now have been successfully read from the file
	return 1;
}
