/******************************************************************************* * Write information about the hill slope being eroded to a file.
 * This data includes:
 * 	index: Interger representing which the order of the output data
 * 	percent: The threshold percent eroded that this data surpassed
 * 	volume: The volume of the original, uneroded hillside
 * 	H: The height of the water surface 
 * 	h: The depth of the water
 * All of this data is needed to continue the erosion process in the event that
 * the code haults for whatever reason.
 ******************************************************************************/

#include "write_data.h"

using namespace std;

int write_data( string file_name, int index, double percent, double volume, double H[LENGTH][WIDTH], double h[LENGTH][WIDTH] )
{
  // Open the file
  ofstream file;
  file.open( file_name.c_str() );
  
  // Write the index
  file << index << std::endl;
  // Write the percent eroded
  file << std::fixed << std::setprecision(4) << percent << std::endl;

  // Set the precision to be much higher now
  file << std::setprecision(14) << std::fixed;
  // Write the volume of the original ridge
  file << volume << std::endl;

  // Write the values of the water surface H
  int i, j;
  for ( i=0; i < LENGTH; i ++ ) {
    for ( j=0; j < LENGTH; j ++ ) {
      file << H[i][j] << ", ";
    }
    file << endl;
  }

  // Write the values of the water depth h
  for ( i=0; i < LENGTH; i ++ ) {
    for ( j=0; j < WIDTH; j ++ ) {
      file << h[i][j] << ", ";
    }
    file << endl;
  }

  // Done
  file.close();

  return 1;
}
